//////////////////////////////////////////////////////////////////////
// driver_configurator.h: interface for the driver_configurator class.
//
// Author	:	David Rokhvarg	<davidr@sangoma.com>
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRIVER_CONFIGURATOR_H__115A6EC1_518C_45E9_AA55_148A8D999B61__INCLUDED_)
#define AFX_DRIVER_CONFIGURATOR_H__115A6EC1_518C_45E9_AA55_148A8D999B61__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <conio.h>
#include <stddef.h>		//for offsetof()

#define __WINDOWS__
#include <wanpipe_defines.h>	//for 'wan_udp_hdr_t'
#include <wanpipe_version.h>	//for DRIVER_VERSION structure
#include <sang_status_defines.h>//return codes
#include <sang_api.h>			//for IOCTL codes
#include <sdla_remora.h>		//Analog card
#include <wanpipe_cfg.h>		//for RBS commands, Media Types (WAN_MEDIA_NONE...)

#include <bit_win.h>
#include <sdlasfm.h>
#include <sdlapci.h>

class driver_configurator  
{
public:
	int set_t1_e1_configuration(sdla_fe_cfg_t *sdla_fe_cfg);

	HANDLE open_api_device(char *api_device_name);
	int init(unsigned int wanpipe_number);
	int get_configration(driver_cfg_t *driver_cfg);
	int set_configration(driver_cfg_t *driver_cfg);
	//Function to check correctness of 'driver_cfg_t' structure.
	int check_driver_cfg_structure(driver_cfg_t *driver_cfg);

	//Function to print contents of 'driver_cfg_t' structure.
	int print_driver_cfg_structure(driver_cfg_t *driver_cfg);

	int print_sdla_fe_cfg_t_structure(sdla_fe_cfg_t *sdla_fe_cfg);
	int print_wanif_conf_t_structure(wanif_conf_t *wanif_conf);

	driver_configurator();
	virtual ~driver_configurator();

	driver_cfg_t	driver_cfg;


private:
	unsigned int wp_number;
	unsigned char wanpipe_name_str[WAN_DRVNAME_SZ];
	HANDLE wp_handle;

	int DoDriverConfigurationCommand(driver_cfg_t *driver_cfg);

	//GET current configuraion of the API driver
	int DoGetDriverConfigurationCommand(driver_cfg_t *driver_cfg);

	//SET new configuration of the API driver
	int DoSetDriverConfigurationCommand(driver_cfg_t *driver_cfg);
};

#endif // !defined(AFX_DRIVER_CONFIGURATOR_H__115A6EC1_518C_45E9_AA55_148A8D999B61__INCLUDED_)
