@echo off
rem #########################################################################################
rem #
rem # Most used WanEc_Client Commands:
rem #	config	- configure Octasic chip and allocate "Echo Canceller" channel for
rem #				interface (for example wanpipe1_if0).
rem #
rem #	mn	- Set Octasic chip in "Mode Normal" power mode
rem #	mpd	- Set Octasic chip in "Mode Power Down" power mode
rem #
rem #	be	- Enable Echo canceller
rem #	bd	- Disable Echo canceller
rem #
rem #	de	- Enable DTMF detection
rem #	dd	- Disable DTMF detection
rem #
rem # For complete list of WanEc_Client Commands type in: wanec_client.exe --h1 <Enter>
rem #########################################################################################

rem # the 'config' command should be done once for EACH channel group:
wanec_client.exe wanpipe1_if0 config
if %errorlevel% NEQ 0 goto failure

rem # all other commands should be repeated for each channel in a channel group:
wanec_client.exe wanpipe1_if0 mn 1
if %errorlevel% NEQ 0 goto failure

wanec_client.exe wanpipe1_if0 be 1
if %errorlevel% NEQ 0 goto failure

wanec_client.exe wanpipe1_if0 de 1 sout
if %errorlevel% NEQ 0 goto failure

rem if we got here, there was no errors
echo ********************************
echo HWEC was configured successfully
echo ********************************
goto end

:failure
rem
echo !!!!!!!!!!!!!!!!!!!!!!!!!!
echo HWEC configuration failed!
echo !!!!!!!!!!!!!!!!!!!!!!!!!!

:end
echo End
